<template>
    <div>
         <button v-if="!value" @click="showModal" type="button" class="btn btn-success btn-sm">Nuevo Archivo</button>
         <button v-if="value" @click="edit" type="button" class="btn btn-success btn-sm" >Editar Archivo</button>
        
         <a :href="file.path_file" target="_blank" v-if="value"  class="btn btn-info btn-sm">Ver Archivo</a>
         <button v-if="value && deleteImage" @click="deleteFile" type="button" class="btn btn-danger btn-sm">Eliminar</button>
         

         <a-modal  title="Cargar Archivo" :visible="visible" @ok="handleOk" :confirmLoading="confirmLoading" @cancel="handleCancel">
            <div class="form-group">
                <label for="exampleInputEmail1">Archivo</label>
              
                <span v-if="allerrors.path" :class="['text-danger']">{{ allerrors.path[0] }}</span>
                <a-upload name="file" v-if="editImage" :multiple="false" action="/api/upload-file" :headers="headers" @change="handleChange" :beforeUpload="beforeUpload" :showUploadList="false" >   
                  <a-button> <a-icon type="upload" /> Seleccionar Archivo </a-button>
                  <a-icon v-if="loading" :type="loading ? 'loading' : 'plus'" />
                  <br>
                </a-upload>
                <div class="col-4 ">

                <img v-if="imageUrl && type == 'IMAGE'" :src="imageUrl" alt="Archivo" class="img-fluid img-thumbnail  rounded" />
                </div>
                <span v-if="atchivo_txt && type != 'IMAGE' ">{{atchivo_txt}}</span>

            </div>
            <div class="form-group">
                <label for="exampleInputEmail1">Descripción</label>
                
                <textarea  v-model="file.summary" class="form-control" :disabled="!editSummary"  ></textarea>
                
            </div>
       
        </a-modal>
    </div>
</template>
<script>
function getBase64(img, callback) {
  const reader = new FileReader();
  reader.addEventListener("load", () => callback(reader.result));
  reader.readAsDataURL(img);
}
export default {
  props: {
    editImage: {
      type: Boolean,
      default: true
    },
    editSummary: {
      type: Boolean,
      default: true
    },
    deleteImage: {
      type: Boolean,
      default: true
    },
    type: {
      type: String,
      required: true
    },
    value: {
      type: Number
    }
  },
  data() {
    return {
      headers: {
        authorization: "authorization-text"
      },
      atchivo_txt: null,

      allerrors: [],
      visible: false,
      imageUrl: null,
      loading: false,
      confirmLoading: false,
      uploading: false,
      file: {
        path_file: "",
        summary: null,
        type: null
      }
    };
  },
  watch: {
    value: function(info) {
      if (this.value) {
        this.getInfo();
      }
    }
  },
  mounted() {
    this.file.type = this.type;
    let _this = this;

    if (_this.value) {
      this.getInfo();
    }
  },

  methods: {
    getInfo() {
      let _this = this;
      _this.file = {
        path_file: "",
        path: "",
        summary: null,
        type: this.type
      };

      axios
        .get("admin/file/show/" + this.value)
        .then(response => {
          const path = response.data.path.split("/");
          _this.file = response.data;
          _this.imageUrl = response.data.path_file;
          _this.atchivo_txt = path[1];
        })
        .catch(error => {
          this.$emit("input", null);
        });
    },
    deleteFile() {
      let _this = this;
      this.$emit("input", null);
      this.file = {
        path_file: "",
        summary: null,
        type: null
      };
      _this.$message.success("Archivo eliminado.");
      /*axios.post("admin/file/delete/" + this.value).then(response => {
        _this.file = {
          path_file: "",
          path: "",
          alt_file: null,
          type: this.type
        };
      });*/
    },
    edit() {
      this.getInfo();
      this.visible = true;
    },
    showModal() {
      this.visible = true;
    },
    handleOk(e) {
      this.confirmLoading = true;
      let _this = this;
      axios
        .post("admin/file/save", this.file)
        .then(res => {
          _this.confirmLoading = false;
          _this.visible = false;
          _this.file = res.data;
          this.$emit("input", res.data.id);

          _this.$message.success("Archivo Guardado");
        })
        .catch(function(error) {
          _this.allerrors = error.response.data.errors;
          _this.confirmLoading = false;
        });
    },
    handleCancel(e) {
      console.log("Clicked cancel button");
      this.visible = false;
    },
    handleChange(info) {
      if (info.file.status === "uploading") {
        this.loading = true;
        return;
      }

      if (info.file.status === "done") {
        let path = info.file.response.path.split("/");
        this.file.path_file = info.file.response.file_path;
        this.file.path = info.file.response.path;
        this.atchivo_txt = path[1];
        // Get this url from response in real world.

        getBase64(info.file.originFileObj, imageUrl => {
          this.imageUrl = imageUrl;
          this.loading = false;
        });
      }
    },
    beforeUpload(file) {
      console.log(file);
      const typeDoc = file.type;

      if (this.type == "PDF") {
        if (typeDoc != "application/pdf") {
          this.$message.error("No es un archivo pdf.");
          return false;
        }
      } else if (this.type == "IMAGE") {
        if (
          typeDoc == "image/jpeg" ||
          typeDoc == "image/gif" ||
          typeDoc == "image/png" ||
          typeDoc == "image/webp" ||
          typeDoc == "image/bmp" ||
          typeDoc == "image/svg+xml"
        ) {
        } else {
          this.$message.error("No es un archivo de imagen.");
          return false;
        }
      } else if (this.type == "VIDEO") {
        if (
          typeDoc == "video/mp4" ||
          typeDoc == "video/webm" ||
          typeDoc == "video/ogg"
        ) {
        } else {
          this.$message.error("No es un archivo de video.");
          return false;
        }
      }
    }
  }
};
</script>

